module m
  use ISO_C_BINDING
  interface
    subroutine sp( mat1, mat2, n, chaine ) bind(C)
      import C_FLOAT, C_DOUBLE, C_INT, C_CHAR
      real(kind=C_FLOAT),  dimension(3,6)  :: mat1
      real(kind=C_DOUBLE), dimension(5,*)  :: mat2
      integer(kind=C_INT)                  :: n
      character(kind=C_CHAR), dimension(*) :: chaine
    end subroutine sp
  end interface

  integer(kind=C_INT), bind(C) :: entier_externe
  real(kind=C_DOUBLE), bind(C) :: double_externe
end module m
program prog
  use m
  use ISO_FORTRAN_ENV
  real(kind=C_FLOAT),  dimension(3,6)     :: m1
  real(kind=C_DOUBLE), dimension(5,7)     :: m2
  character(kind=C_CHAR,len=*), parameter :: chaine = &
              "Interoperabilite Fortran/C"//C_NULL_CHAR
  integer i

  entier_externe = 1756
  double_externe = acos( -1._C_DOUBLE )
  call random_number( m1 )
  call random_number( m2 )
  call sp( m1, m2, 7_C_INT, chaine )
  write( OUTPUT_UNIT, '(/, 2a, "Matrices Fortran 2003",/)' ) C_HORIZONTAL_TAB, &
                                                             C_HORIZONTAL_TAB
  do i=1, size(m1,1)
    write( OUTPUT_UNIT, '(6f9.6)' ) m1(i,:)
  end do
  print *
  do i=1, size(m2,1)
    write( OUTPUT_UNIT, '(7f9.6)' ) m2(i,:)
  end do
end program prog
