module creer_liberer
  use ISO_C_BINDING
  real(kind=C_FLOAT), dimension(:), allocatable, target :: vecteur
contains
  subroutine for_alloc( pointeurC, n ) BIND(C, name="F_alloc")
    type(C_PTR), intent(out)   :: pointeurC
    integer(kind=C_INT), VALUE :: n
    allocate( vecteur(n) )
    call random_number( vecteur )
    pointeurC = C_LOC( vecteur )
  end subroutine for_alloc
  subroutine for_free() BIND(C, name="F_free")
    if ( allocated(vecteur) ) deallocate( vecteur )
  end subroutine for_free
end module creer_liberer

module calculs
  use ISO_C_BINDING
contains
  subroutine moyenne( pointeurC, n ) BIND(C, name="F_moyenne")
    type(C_PTR),    VALUE                     :: pointeurC
    integer(C_INT), VALUE                     :: n
    real(kind=C_FLOAT), dimension(:), pointer :: p
    call C_F_POINTER( CPTR=pointeurC, FPTR=p, shape=(/ n /) )
    print *, "MOYENNE =", sum( p ) / n
  end subroutine moyenne
end module calculs
