module m
  use ISO_C_BINDING
  type, bind(C) :: pair
    integer(kind=C_INT) i
    integer(kind=C_INT) j
  end type pair

  type, bind(C) :: cellule
    integer(kind=C_INT) n
    real(kind=C_DOUBLE) r
    integer(kind=C_INT) n_ch
    type(C_PTR)         p
    integer(kind=C_INT) n_pairs
    type(C_PTR)         q
  end type cellule

  type(C_PTR), dimension(:), pointer :: tab_ptr
  character(len=:,kind=C_CHAR), pointer :: chaine
  type(pair), dimension(:), pointer :: p_pair
contains
  subroutine sp( c ) bind( C, name="Ap_For" )
    use ISO_FORTRAN_ENV
    type(cellule), VALUE :: c
    integer i, n_char

    call C_F_POINTER( CPTR=c%p, FPTR=tab_ptr, shape=(/ c%n_ch /) )
    do i=1,c%n_ch
      call C_F_POINTER( CPTR=tab_ptr(i), FPTR=chaine )
      n_char = 1
      do while( chaine(n_char:n_char) /= C_NULL_CHAR )
        n_char = n_char + 1
      end do
      write( OUTPUT_UNIT, * ) chaine(1:n_char)
    end do

    call C_F_POINTER( CPTR=c%q, FPTR=p_pair, shape=(/ c%n_pairs /) )
    do i=1,c%n_pairs
      write( OUTPUT_UNIT, * ) p_pair(i)%i, p_pair(i)%j
    end do
  end subroutine sp
end module m
