program io
  use ISO_FORTRAN_ENV
  implicit none
  character(len=256) :: message
  integer(kind=2)    :: stat = 0
  integer            :: i
  real               :: a, b, c
  integer            :: id
  real, dimension(1024*1024) :: tab

  namelist /var/i, a, b, c

  open( UNIT=1,              &
        FILE="io_2_.data",   &
        FORM="formatted",    &
        ACTION="read",       &
        ACCESS="sequential", &
        ASYNCHRONOUS="yes",  &
        ROUND="up" )

  open( UNIT=OUTPUT_UNIT, &
        SIGN="plus" )
  do
    read( UNIT=1,                            &
          FMT='(i4,1x,rd,f8.6,1x,rn,f10.1)', &
          IOSTAT=stat,                       &
          ASYNCHRONOUS="yes",                &
          ID=id,                             &
          IOMSG=message ) i, a, b
    if ( stat /= 0 ) then; call trait_erreur; exit; end if
    call random_number( tab )
    write( UNIT=OUTPUT_UNIT, FMT=* ) tab( [lbound(tab), ubound(tab) ] )
    WAIT( UNIT=1, ID=id, IOSTAT=stat, IOMSG=message )
    if ( stat /= 0 ) then; call trait_erreur; exit; end if
    c = i*a+b
    write( OUTPUT_UNIT, NML=var )
  end do

  close( UNIT=1 )

contains
  subroutine trait_erreur
    if ( is_iostat_end( stat ) ) &
      write( OUTPUT_UNIT, '("Fin de fichier atteinte.")' )
    if ( stat > 0 ) write( OUTPUT_UNIT, * ) message
  end subroutine trait_erreur
end program io
