module couleur_mod
  type couleur
    character(len=:), allocatable :: nom; integer, dimension(3) :: code_rvb
    contains
      procedure :: ecr_format
      generic :: write(formatted) => ecr_format ! <=== generic binding.
  end type couleur
contains
  subroutine ecr_format( dtv, unit, iotype, v_list, etat, msg )
    class(couleur),        intent(in)    :: dtv
    integer,               intent(in)    :: unit
    character(len=*),      intent(in)    :: iotype
    integer, dimension(:), intent(in)    :: v_list
    integer,               intent(out)   :: etat
    character(len=*),      intent(inout) :: msg
    character(len=13), dimension(4)      :: formats

    formats(1) = '(*(1X,I0))'
    if (size(v_list) > 0) then
      write( formats(2), '(A, I2.2, A)' ) "(A,3I", v_list(1), ")" 
      write( formats(3), '(A, I2.2, A)' ) "(3I",   v_list(1), ")" 
    end if
    formats(4) = MERGE(TSOURCE=formats(1), &
                       FSOURCE=MERGE(TSOURCE=formats(2), &
                                     FSOURCE=formats(3), &
                                     MASK=iotype=='DTCOMPLET'), &
                       MASK=size(v_list)==0)
    print *,formats(4), iotype
    if (iotype == 'DTCOMPLET') write(unit=unit, fmt=formats(4)) dtv%nom, dtv%code_rvb
    if (iotype /= 'DTCOMPLET') write(unit=unit, fmt=formats(4)) dtv%code_rvb
  end subroutine ecr_format
end module couleur_mod
PROGRAM exemple
  USE couleur_mod
  IMPLICIT NONE
  TYPE(couleur)      :: c1, c2
  REAL               :: x, y
  INTEGER            :: i, ios
  CHARACTER(len=132) :: message
  NAMELIST/liste/ x, y, c1

  c1 = couleur( nom="gris_souris",     code_rvb=[158, 158, 158] )
  c2 = couleur( nom="gris_anthracite", code_rvb=[48, 48, 48] )
  i = 1756; x = 9.81; y = 2.718
  WRITE( UNIT=1, FMT="(I0, /, DT, /, 2F6.2, / )", &
         IOSTAT=ios, IOMSG=message ) i, c1, x, y
  if( ios /= 0 ) PRINT *, ios, message
  WRITE( UNIT=1, FMT="(I0, /, DT 'COMPLET'(6), /, 2F6.2, / )", &
         IOSTAT=ios, IOMSG=message ) i, c1, x, y
  if( ios /= 0 ) PRINT *, ios, message
  WRITE( UNIT=1, FMT="(F7.3, /, DT(7), /, DT 'COMPLET'(5), / )",  &
         IOSTAT=ios, IOMSG=message ) x, c1, c2
  if( ios /= 0 ) PRINT *, ios, message
  WRITE( UNIT=1, FMT=*, IOSTAT=ios, IOMSG=message ) x, c1, i, y
  if( ios /= 0 ) PRINT *, ios, message
  WRITE( UNIT=1, NML=liste )
  if( ios /= 0 ) PRINT *, ios, message
END PROGRAM exemple
