module m
  use ISO_FORTRAN_ENV
  implicit none
  type vecteur
    integer n
    real, dimension(:), pointer :: p
  end type vecteur

contains

  subroutine copy( v2, v1 )
    type(vecteur), POINTER, INTENT(INOUT) :: v2
    type(vecteur), POINTER, INTENT(IN)    :: v1

    if ( associated(v2) .AND. &
         associated( v1, v2 ) ) return
    allocate( v2 )
    v2%n = v1%n
    allocate( v2%p(v2%n) )
    v2%p = v1%p
  end subroutine copy
end module m
program copie
  use m
  implicit none
  integer n

  type(vecteur), pointer :: vec1, vec2
  allocate( vec1 )
  read *, vec1%n
  allocate( vec1%p(vec1%n) )
  call random_number( vec1%p )
  call copy( vec1, vec1 )
  call copy( vec2, vec1 )
  write( UNIT=OUTPUT_UNIT, FMT=* ) vec2%p( [ 1, ubound(vec2%p) ] )
  deallocate( vec1%p )
  deallocate( vec2%p )
  deallocate( vec1 )
  deallocate( vec2 )
end program copie
