module m
  implicit none
  abstract interface
    function func(x)
      double precision, intent(in) :: x
      double precision func
    end function func
  end interface
contains

  function integrale( borne_i, borne_s, pas, f )
    double precision :: borne_i, borne_s
    integer          :: pas
    PROCEDURE(func)  :: f
    double precision :: integrale
    integer          :: i
    double precision :: h
    
    h = (borne_s - borne_i)/pas
    integrale = 0.
    do i=0, pas-1
      integrale = integrale + h*f(borne_i+i*h)
    end do
  end function integrale
  
  function carre( x )
    double precision, intent(in) :: x
    double precision carre
  
    carre = x*x
  end function carre
end module m
program p
  use m
  implicit none
  double precision :: b_inf, b_sup, aire
  integer          :: pas

  b_inf = 1.
  b_sup = 6.
  pas = 200000
  aire = integrale( b_inf, b_sup, pas, carre )
  print '("Aire : ", f11.6)', aire
end program p
