module m
  integer, parameter :: single=kind(1.0), double=kind(1.d0)
  type matrix(K, N, M)
    integer, kind                :: K
    integer, len                 :: N, M
    real(kind=K), dimension(N,M) :: a
  contains
    PROCEDURE, PRIVATE :: add_s
    PROCEDURE, PRIVATE :: add_d
!    PROCEDURE, PRIVATE :: affect_s
!    PROCEDURE, PRIVATE :: affect_d
    GENERIC :: OPERATOR(+)   => add_s, add_d
!    GENERIC :: ASSIGNMENT(=) => affect_s, affect_d
  end type matrix
contains
  function add_s( a, b )
    class(matrix(K=single, N=*, M=*)), intent(in)  :: a, b
    type(matrix(K=single, N=:, M=:)), allocatable  :: add_s ! "type" et non "class".
    if( all( shape(a%a) /= shape(b%a) ) ) stop "Erreur : objets non conformants"
    allocate( matrix(K=single, N=a%N, M=a%M) :: add_s )
    add_s%a(:,:) = a%a(:,:) + b%a(:,:)
  end function add_s
  function add_d( a, b )
    class(matrix(K=double, N=*, M=*)), intent(in) :: a, b
    type(matrix(K=double, N=a%N, M=a%M))          :: add_d ! "type" et non "class".
    if( all( shape(a%a) /= shape(b%a) ) ) stop "Erreur : objets non conformants"
    add_d%a(:,:) = a%a(:,:) + b%a(:,:)
  end function add_d
  !---------------------------------
  subroutine affect_s( a, b )
    class(matrix(K=single, N=*, M=*)), intent(inout) :: a
    class(matrix(K=single, N=*, M=*)), intent(in)    :: b
    if( all( shape(a%a) /= shape(b%a) ) ) stop "Erreur : objets non conformants"
    a%a(:,:) = b%a(:,:)
  end subroutine affect_s
  !---------------------------------
  subroutine affect_d( a, b )
    class(matrix(K=double, N=*, M=*)), intent(inout) :: a
    class(matrix(K=double, N=*, M=*)), intent(in)    :: b
    if( all( shape(a%a) /= shape(b%a) ) ) stop "Erreur : objets non conformants"
    a%a(:,:) = b%a(:,:)
  end subroutine affect_d
end module m
program p
  use m
  type(matrix(K=kind(0.d0), N=5,  M=10)) :: mat1d, mat2d, mat3d
  type(matrix(K=kind(0.),   N=20, M=60)) :: mat1s, mat2s, mat3s

  mat1s = mat2s + mat3s ! Appel  add_s puis affect_s
  mat1d = mat2d + mat3d ! Appel  add_d puis affect_d
end program p
