module m
  implicit none
  type t(k)
    integer, KIND :: k
    real(kind=k),pointer,dimension(:) :: v => null()
  contains
    FINAL :: finalize_scal , finalize_vect
  end type t
contains
  subroutine finalize_scal(x) !--> Arg. scalaire
    type(t(k=4)) :: x

    if( associated(x%v) ) deallocate(x%v)
  end subroutine finalize_scal
  subroutine finalize_vect(x) !--> Arg. vecteur 
    type(t(k=4)), dimension(:) :: x
    integer i

    do i=1,size(x)
      if( associated(x(i)%v) ) deallocate(x(i)%v)
    end do
  end subroutine finalize_vect
end module m
program p
  use m
  implicit none
  type(t(k=4)), dimension(:), allocatable :: obj 
  integer i

  allocate( obj(100) )
  do i=1,100
    allocate( obj(i)%v(100) )
    call random_number( obj(i)%v )
    print *, obj(i)%v(100)
  end do
  deallocate( obj )
end program p
