module m
  type base
    real, dimension(:), pointer :: p => NULL()
    contains
      FINAL :: fin_base
  end type base
  type, extends(base) :: t
    real, dimension(:), pointer :: q => NULL()
    contains
      FINAL :: fin_t
  end type t

contains
  subroutine fin_base( this )
    type(base) :: this
    print *,"Finalisation du type base."
    if ( associated(this%p) ) deallocate(this%p)
  end subroutine fin_base

  subroutine fin_t( this )
    type(t) :: this
    print *,"Finalisation du type t."
    if ( associated(this%q) ) deallocate(this%q)
  end subroutine fin_t
end module m

program type_extent_final
  use m
  type(t), allocatable :: obj

  allocate( obj ); allocate( obj%p(100) )
  call random_number( obj%p )
  print *, obj%p( [ 1, 50, 100 ] )
  allocate( obj%q(200) )
  call random_number( obj%q )
  print *, obj%q( [ 1, 50, 100, 150, 200 ] )
  deallocate( obj )
end program type_extent_final
