module m
  implicit none
  integer, parameter :: simple = kind(1.)
  integer, parameter :: double = kind(1.d0)
  type matrix(K, N, M)
    integer, kind :: K; integer, len  :: N, M
    real(kind=K), dimension(N,M) :: a=1.
  contains
    PROCEDURE, PRIVATE :: maxs => max_s
    PROCEDURE, PRIVATE :: maxd => max_d
    PROCEDURE, PRIVATE :: sorties => sortie_mat_s
    PROCEDURE, PRIVATE :: sortied => sortie_mat_d
    GENERIC :: max => maxs, maxd
    GENERIC :: sortie => sorties, sortied
  end type matrix
!
  type, extends(matrix) :: matrix_e( LN )
    integer, len :: LN = 30
    character(len=LN) :: nom
  contains
    PROCEDURE, PRIVATE :: sorties => sortie_mat_e_s
    PROCEDURE, PRIVATE :: sortied => sortie_mat_e_d
  end type matrix_e
contains
  subroutine sortie_mat_s( this )
    class(matrix(K=simple, N=*, M=*)), intent(in) :: this
 
    !print *, "dernier lment : ", this%a(this%N,this%M)
    print '(2(a,i0),a)', "ORDRE = [ ", this%N, ",", this%M, " ]"
    print *, "dernier lment => ", &
             this%a( ubound(this%a,1), ubound(this%a,2) )
  end subroutine sortie_mat_s

  subroutine sortie_mat_d( this )
    class(matrix(K=double, N=*, M=*)), intent(in) :: this
 
    !print *, "dernier lment : ", this%a(this%N,this%M)
    print '(2(a,i0),a)', "ORDRE = [ ", this%N, ",", this%M, " ]"
    print *, "dernier lment => ", &
             this%a( ubound(this%a,1), ubound(this%a,2) )
  end subroutine sortie_mat_d

  subroutine sortie_mat_e_s( this )
    class(matrix_e(K=simple, N=*, M=*, LN=*)), intent(in) :: this

    call this%matrix%sorties
    print *, "nom = ", this%nom
  end subroutine sortie_mat_e_s

  subroutine sortie_mat_e_d( this )
    class(matrix_e(K=double, N=*, M=*, LN=*)), intent(in) :: this

    call this%matrix%sortied
    print *, "nom = ", this%nom
  end subroutine sortie_mat_e_d
!
  real function max_s( this )
    class(matrix(K=simple, N=*, M=*)), intent(in) :: this

    max_s = MAXVAL( array=this%a )
  end function max_s
!
  real(kind=double) function max_d( this )
    class(matrix(K=double, N=*, M=*)), intent(in) :: this

    max_d = MAXVAL( array=this%a )
  end function max_d
end module m
!
program p
  use m
  type(matrix  (K=simple, N=10, M=20)) :: objs
  type(matrix_e(K=double, N=20, M=50)) :: objd_e

  objs = matrix(K=simple, N=10, M=20)( &
            a=reshape( source=[ (i,i=1,10*20) ], shape=shape(objs%a) ) )
  objd_e = matrix_e(K=double, N=20, M=50)( &
            a  =reshape( source=[ (i,i=1,20*50) ], shape=shape(objd_e%a) ), &
            nom="matrice gnrale" )
  call objs%sortie; call objd_e%sortie
  print *, "MAXS = ", objs%max(), ", MAXD = ", objd_e%max()
end program p
