module surcharge
  use ISO_FORTRAN_ENV
  type base
    real x
    contains
      procedure, private :: plus => plus_base
      procedure, private :: egal => egal_base
      procedure          :: affiche => affiche_base
      generic :: operator(+)   => plus
      generic :: assignment(=) => egal
  end type base
  type, extends(base) :: etendu
    integer i
    contains
      procedure, private :: plus => plus_etendu
      procedure, private :: egal => egal_etendu
      procedure          :: affiche => affiche_etendu
  end type etendu
contains
  function plus_base( this, b )
    class(base), intent(in)  :: this, b
    class(base), allocatable :: plus_base

    allocate( base :: plus_base ); plus_base%x = this%x + b%x
  end function plus_base
  function plus_etendu( this, b )
    class(etendu), intent(in)  :: this         ! doit respecter l'interface
    class(base),  intent(in)  :: b             ! de la fonction "plus_base"
    class(base),  allocatable :: plus_etendu   ! hormis l'argument this.

    if ( SAME_TYPE_AS( b, this ) ) then
      allocate( etendu :: plus_etendu )
    else
      allocate( base :: plus_etendu )
    end if
    select type (plus_etendu)
      type is (base)
        plus_etendu = this%base + b
      type is (etendu)
        plus_etendu%base = this%base + b
        select type (b)
          type is (etendu)
            plus_etendu%i = this%i + b%i
        end select
    end select
  end function plus_etendu
  subroutine egal_base( this, b )
    class(base), intent(out) :: this
    class(base), intent(in)  :: b

    this%x = b%x
  end subroutine egal_base
  subroutine egal_etendu( this, b )
    class(etendu), intent(out) :: this
    class(base),  intent(in)  :: b

    this%base = b
    select type (b)
      type is (etendu)
        this%i = b%i
    end select
  end subroutine egal_etendu
  subroutine affiche_base( this )
    class(base), intent(in) :: this

    write( OUTPUT_UNIT, '(a, f0.3)' ) "X = ", this%x
  end subroutine affiche_base
  subroutine affiche_etendu( this )
    class(etendu), intent(in) :: this

    call this%base%affiche; write( OUTPUT_UNIT, '(a, i0,/)' ) "I = ", this%i
  end subroutine affiche_etendu
end module surcharge
program prog
  use surcharge
  implicit none
  real, parameter :: pi = acos(-1.)
  type(etendu)    :: e1, e2, e3
  type(base)      :: b1, b2

  b1 = base  (x = pi)
  b2 = base  (x = pi/2.)
  e1 = etendu(x = pi/3., i = 2)
  e2 = etendu(x = pi/6., i = 3)
  e3 = e1 + e2
  call e3%affiche

  !e3%i = 0
  e3  = b1 + e2
  call e3%affiche
  
  e3  = e2 + b1
  call e3%affiche

  e3  = b1 + b2
  call e3%affiche

  b2  = e1 + e3
  call b2%affiche
end program prog
