module m
  type mycomplex
    real :: rho, theta                      !<=== Coordonnes polaires
  end type mycomplex
  !
  interface mycomplex
    module procedure complex_to_mycomplex, two_reals_to_mycomplex
  end interface mycomplex
contains
  function complex_to_mycomplex(c) result(myc)
    complex, intent(in) :: c
    type(mycomplex)     :: myc
    real, parameter     :: PI = acos(-1.)
    real x, y
    
    myc%rho = abs(c)
    x = real(c) ; y = aimag(c)
    myc%theta = atan(y/x)
    if ( x < 0. .AND. y < 0. ) myc%theta = myc%theta - PI
    if ( x < 0. .AND. y > 0. ) myc%theta = myc%theta + PI
  end function complex_to_mycomplex
  function two_reals_to_mycomplex(x,y) result(myc)
    real, intent(in) :: x, y
    type(mycomplex)  :: myc 
    
    myc%rho   = sqrt(x*x + y*y)
    myc%theta = atan2(y, x)
  end function two_reals_to_mycomplex
end module m
program p
  use ISO_FORTRAN_ENV
  use m
  type(mycomplex) :: a, b, c
  complex         :: w

  w = ( 0.,1. )
  a = mycomplex( theta=5.6, rho=1.0 )       ! Appel constructeur intrinsque
  b = mycomplex( w )                        ! Appel  complex_to_mycomplex
  c = mycomplex( x=0.5, y=3.**.5/2. )       ! Appel  two_reals_to_mycomplex
  write( OUTPUT_UNIT, * ) "A(rho,theta) : ", a%rho, a%theta
  write( OUTPUT_UNIT, * ) "B(rho,theta) : ", b%rho, b%theta
  write( OUTPUT_UNIT, * ) "C(rho,theta) : ", c%rho, c%theta
end program p
