module m
  use ISO_FORTRAN_ENV, only : OUTPUT_UNIT
  type couleur
    integer, dimension(3) :: code_rvb
  end type couleur
  type, extends(couleur) :: coul_label
    character(len=:), allocatable :: nom
  end type coul_label
contains
  subroutine output(obj)
    CLASS(couleur) :: obj

    select type(obj)
      CLASS is(couleur)
        write(OUTPUT_UNIT, *) "Composantes : ", obj%code_rvb
      CLASS is(coul_label)
        write(OUTPUT_UNIT, *) "Nom : ",           trim(obj%nom), &
                              ", Composantes : ", obj%code_rvb
    end select
  end subroutine output
!
  subroutine init(obj, rvb, nom)
    CLASS(couleur),             intent(out) :: obj
    integer, dimension(:),      intent(in)  :: rvb
    character(len=*), optional, intent(in)  :: nom

    obj%code_rvb = rvb
    select type(obj)
      CLASS is(coul_label)
        if (.not.present(nom)) then
          obj%nom = "Noir"
        else
          obj%nom = nom
        end if
    end select
  end subroutine init
end module m
program p
  use m
  CLASS(couleur), allocatable :: c
  type(couleur) :: coul

  allocate(coul_label :: c)
  call init(obj=c, rvb=[ 158, 158, 158 ], nom="Gris souris")
  call output(c)
  deallocate(c)
!
  coul = couleur(code_rvb=[ 158, 158, 158 ])
  allocate(c, source=coul)
  call output(c)
  deallocate(c)
end program p
