module m
  use ISO_FORTRAN_ENV
  TYPE mytype
    private
      real    :: x
      integer :: i
      PROCEDURE(proc), public, POINTER, PASS   :: p
      PROCEDURE(func), public, POINTER, NOPASS :: q
  END TYPE mytype
  abstract interface
    subroutine proc( this, r, i )
      import mytype
      CLASS(mytype), intent(inout) :: this
      real,          intent(in)    :: r
      integer,       intent(in)    :: i
    end subroutine proc
    function func( x )
      real x, func
    end function func
  end interface
contains
  subroutine set( this, r, i )
    CLASS(mytype), intent(inout) :: this
    real,          intent(in)    :: r
    integer,       intent(in)    :: i

    this%x = r; this%i = i
    write( OUTPUT_UNIT, '("THIS%X = ", f6.2,/,"THIS%I = ", i6)' ) &
                            this%x, this%i
  end subroutine set
  function f( x )
    real x, f

    f = x*exp( x )
  end function f
end module m
program p
  use m
  TYPE(mytype) :: a
  real         :: y

  a%p => set
  call a%p( 3.14,  100 ) ! quivalent  "call set( a, 3.14, 100 )"
  a%q => f
  y = a%q( Log( 3.14 ) )
  write( OUTPUT_UNIT, '("Y = ", f6.2)' ) y
end program p
